/*
  CPP_CONTEST=2012
  CPP_PROBLEM=B
  CPP_LANG=C+OPENMP+MPI
  CPP_NUM_CORES=8
  CPP_PROCESSES_PER_NODE=1
*/

/* RECORD
Tomás Ramírez García, Víctor Manuel Ruiz Sánchez 
students of the University of Murcia, Spain
In the II Spanish Parallel Programming Contest, Elche, Spain
September 19, 2012
time 2392 msec
speed-up 7.61
*/

#include <stdlib.h>
#include <omp.h>

extern void escribir(int *m, int t);
 
void quicksort(int *d,int izq,int der,int n)
{
  int i,j,piv,t;

  if(izq>=der)
    return;
  else
  {
    i=izq+1;
    j=der;
    piv=d[izq];
    while(i<=j)
    {
      while(i<=der && d[i]<=piv)
        i++;
      while(d[j]>piv)
        j--;
      if(i<=der && j>i)
      {
        t=d[i];
        d[i]=d[j];
        d[j]=t;
      }
    }
    if(j>izq)
    {
      d[izq]=d[j];
      d[j]=piv;
    }


   		quicksort(d,izq,j-1,n);
    		quicksort(d,j+1,der,n);
     }
}

void transpose(int n,int *m,int *r)
{
  int i,j;


  for(i=0;i<n;i++)
  {
    #pragma omp parallel for private(j)
    for(j=i;j<n;j++)
    {
       r[i*n+j]=m[j*n+i];
       r[j*n+i]=m[i*n+j];
    }
  }
}

void rowsorting(int t,int *a)
{
  int i;

#pragma omp parallel for default(shared) private(i)
  for(i=0;i<t;i++)
  {
    quicksort(&a[i*t],0,t-1,t);
  }
#pragma omp barrier

}
 
void sorting(int t, int *a, int n, int np)
{
  int* mtemp=(int *) malloc(sizeof(int)*t*t);
  omp_set_num_threads(8);
  rowsorting(t,a);
  transpose(t,a,mtemp);
  rowsorting(t,mtemp);
  transpose(t,mtemp,a);
#ifdef DEBUG
// While debugging the matrix and the numbers are written
      escribir(a,t);
#endif
}


